// ---------------------------------------------------------------------------
// bagi.cpp
//
// An example of an indirect bag implementation.
//
// This sample program creates 6 string objects
// and stores them in a bag.
// ---------------------------------------------------------------------------

#include <classlib/bags.h>
#include <iostream.h>
#include <strstrea.h>
#include <cstring.h>


typedef string MyClass;
typedef TIBagAsVector<MyClass> ContainerType;
typedef TIBagAsVectorIterator<MyClass> IteratorType;

const int MaxItems=6;

void ForEachCallBack(MyClass& mc, void* s)
{
		cout << (char*)s << mc << endl;
}

void AddItems(ContainerType& container, int numItems)
{
		for( int i=numItems; i>0; i-- )
				{
				char buf[80];
				ostrstream str( buf, sizeof(buf) );
				str << i << " hello" << ends;
				cout << "Adding string " << buf << " to bag." << endl;
				container.Add( new string(buf) );
				}
}

void UseForwardIterator(ContainerType& container)
{
		IteratorType iterator(container);
		while( iterator )
				{
				cout << *iterator.Current() << endl;
				iterator++;
				}
}

int main()
{
		ContainerType container(MaxItems);
		AddItems(container, MaxItems);

		cout << "--- Starting ForEach" << endl;
		container.ForEach(ForEachCallBack, (void*)"FE ");

		cout << "--- Starting Iterator (forward)" << endl;
		UseForwardIterator(container);

		return 0;
}
